import acm.program.*;
import acm.util.*;
import java.io.*;

public class FindTheMedian extends ConsoleProgram{
	
	/* The maximum possible score. */ 
	private static final int MAX_SCORE = 120;
	
	/* The file containing the list of scores. */ 
	private static final String SCORES_FILE = "midterm-scores.txt";
	
	public void run() { 
		int[] scores = readMidtermScores(); 
		println("The median score is " + medianScore(scores));
	}
	
	private int medianScore(int[] scores){
		int numEntries = countScores(scores);
		double halfTheEntries = numEntries / 2.0;
		
		int cumulativeTotal = 0;
		for(int i = 0; i <= MAX_SCORE; i++){
			cumulativeTotal += scores[i];
			
			if(cumulativeTotal >= halfTheEntries)
				return i;
		}
		
		return 0;
	}
	
	private int countScores(int[] scores){
		int total = 0;
		for(int i = 0; i < scores.length; i++){
			total += scores[i];
		}
		return total;
	}
	
	private int[] readMidtermScores(){
		try{
			BufferedReader br = new BufferedReader(new FileReader(SCORES_FILE));
			int[] result = new int[MAX_SCORE + 1];
			while(true){
				String line = br.readLine();
				if(line == null) break;
				
				int score = Integer.parseInt(line);
				result[score]++;
			}
			return result;
		}catch(IOException e){
			throw new ErrorException(e);
		}
	}
}